/* WAV file ôʬΥإåե
 * shige
 * 10/01 2000
 * wavio.h
 * 
 * $Id: wavio.h,v 1.1 2000-10-01 13:17:12+09 shige Exp $
 */
#ifndef __WAVIO_H__
#define __WAVIO_H__

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "error.h"

typedef struct {
    short int fmcode;
    short int channel;
    long int smplrate;
    long int bytepersec;
    short int blocksize;
    short int bitpersmpl;
    /* short int extendedsize; */
    long int hlen;
    long int datalen;
} WAVdata;

#ifdef __WAVIO_C__
# define sto4bytelittlei(s) ((s[3]<<24)|(s[2]<<16)|(s[1]<<8)|s[0])
# define sto2bytelittlei(s) ((s[1]<<8)|s[0])
#endif /* __WAVIO_C__ */

#ifdef __WAVIO_C__
# define EXTERN_WAVIO 
#else
# define EXTERN_WAVIO extern 
#endif

EXTERN_WAVIO int getWAVheader(FILE *file,WAVdata *wd);
EXTERN_WAVIO int chWAVheader(WAVdata *wd1,WAVdata *wd2);
EXTERN_WAVIO void putallWAVheader(FILE *file,WAVdata *wd,int N);
EXTERN_WAVIO void putWAVdata(FILE *file1,FILE *file2,int pos,int len);
EXTERN_WAVIO int read4bytetolittlei(FILE *file,long int *J);
EXTERN_WAVIO int read2bytetolittlei(FILE *file,short int *J);
EXTERN_WAVIO void writelittleito4byte(FILE *file,unsigned long int n);
EXTERN_WAVIO void writelittleito2byte(FILE *file,unsigned short int n);

#endif /* __WAVIO_H__ */
